--------------------------------------------------------------------------------
-- Module Tool: Tool_09.lua
-- Name: TL09: Track Notes Checker
-- Version: 1.0b3
-- Author: ulneiz (Spain)
--------------------------------------------------------------------------------

--------------------------------------------------------------------------------
-- PRINCIPAL FUNCTIONS
--------------------------------------------------------------------------------

--change_track
function tnc_tr_chng(song, sti )
  song = renoise.song()
  local function tr_chng_nfr()
    --- ---
    if song.selected_track.type == renoise.Track.TRACK_TYPE_SEQUENCER then
      vb.views["TNC_TXT_STI"].text = ( "Track | %s" ):format( song.selected_track_index ) --selected track (1)
    end
    if song.selected_track.type == renoise.Track.TRACK_TYPE_GROUP then
      vb.views["TNC_TXT_STI"].text = ( "Group | %s" ):format( song.selected_track_index ) --selected group (1)
    end
    if song.selected_track.type == renoise.Track.TRACK_TYPE_SEND then
      vb.views["TNC_TXT_STI"].text = ( "Send | %s" ):format( song.selected_track_index ) --selected send (1)
    end
    if song.selected_track.type == renoise.Track.TRACK_TYPE_MASTER then
      vb.views["TNC_TXT_STI"].text = ( "Master | %s" ):format( song.selected_track_index ) --selected master (1)
    end
    --- ---
    vb.views["TNC_TXT_TR"].text = ( "%s" ):format( song.tracks[ song.selected_track_index ].name ) --Name selected track (2)
    vb.views["TNC_TXT_TR"].color = ( song.tracks[ song.selected_track_index ].color ) --Color selected track (3)
    --- ---
    if ( vb.views['TNC_CB'].value == true ) then
      tnc_df() --default values
    end
  end
  tr_chng_nfr()
  song.selected_track_index_observable:add_notifier( tr_chng_nfr ) --(1)
  song.tracks[song.selected_track_index].name_observable:add_notifier( tr_chng_nfr ) --(2)
  song.tracks[song.selected_track_index].color_observable:add_notifier( tr_chng_nfr ) --(3)

end
renoise.tool().app_new_document_observable:add_notifier( tnc_tr_chng )

--- ---

--return track_color for note columns
function tnc_tr_color( song )
  song = renoise.song()
  local function tr_clr_nfr()  
    song.tracks[song.selected_track_index].color_observable:add_notifier( tnc_tr_color )
  end
  return
  song.tracks[song.selected_track_index].color 
end
renoise.tool().app_new_document_observable:add_notifier( tnc_tr_color )


--select note column
function tnc_nc( nc, song )
  song = renoise.song()
  if ( song.selected_track.type == renoise.Track.TRACK_TYPE_SEQUENCER ) then
    if ( song.tracks[ song.selected_track_index ].visible_note_columns < nc ) then
      song.tracks[ song.selected_track_index ].visible_note_columns = nc
    end
    song.selected_note_column_index = nc
  end
end

--default values
function tnc_df( tx, cl, i )
  tx = '---'
  cl = { 0x20,0x00,0x00 }
  for i = 1, 12 do
    vb.views["TNC_NC_"..i..""].text = tx
    vb.views["TNC_NC_"..i..""].color = cl
    vb.views["TN_NC_NM_"..i..""].text = ' ---'
    vb.views["TN_NC_NOTE_"..i..""].text = ''
  end
end

--LPS: lines Per Second
function tnc_lps( song )
  song = renoise.song()

  local function tnc_calculate_lps( bmp, lpb, lps )
    bmp = song.transport.bpm
    lpb = song.transport.lpb
    lps = ( bmp * lpb ) / 60
    vb.views["TNC_TXT_LPS"].text = string.format( "LPS: %.6s", lps ) --"LPS: "..lps..""
  end
  if vb.views["TNC_CB"].value == false then
    vb.views["TNC_TXT_LPS"].text = "LPS: ---"
    if ( song.transport.bpm_observable:has_notifier( tnc_calculate_lps ) ) then
      song.transport.bpm_observable:remove_notifier( tnc_calculate_lps )
    end
    if ( song.transport.lpb_observable:has_notifier( tnc_calculate_lps ) ) then
      song.transport.lpb_observable:remove_notifier( tnc_calculate_lps )
    end
  else 
    tnc_calculate_lps()
    if not ( song.transport.bpm_observable:has_notifier( tnc_calculate_lps ) ) then
      song.transport.bpm_observable:add_notifier( tnc_calculate_lps )
    end
    if not ( song.transport.lpb_observable:has_notifier( tnc_calculate_lps ) ) then
      song.transport.lpb_observable:add_notifier( tnc_calculate_lps )
    end
  end
end


--play modes song
function tnc_play_song( song, play_mode )
  tnc_df()
  song = renoise.song()
  
  play_mode = renoise.Transport.PLAYMODE_RESTART_PATTERN
  song.transport:start( play_mode )
end

function tnc_play_song_cont( song, play_mode )
  song = renoise.song()
  play_mode = renoise.Transport.PLAYMODE_CONTINUE_PATTERN
  song.transport:start( play_mode )
end

function tnc_stp_song_first( song )
  song = renoise.song()
  song.transport:stop()
  song.selected_line_index = 1 --jump line 00 (the first)
end

--nav
function tnc_tr_left( song )
  song = renoise.song()
  if song.selected_track_index > 1 then
    song:select_previous_track()
  end
end

function tnc_tr_right( song )
  song = renoise.song()
  if song.selected_track_index < song.sequencer_track_count then
    song:select_next_track()
  end
end

function tnc_tr_up( song, ssi )
  song = renoise.song()
  ssi = song.selected_sequence_index
  if song.selected_sequence_index > 1 then
    song.selected_sequence_index = ssi - 1 --select previous pattern    
  end
end

function tnc_tr_down( song, ssi )
  song = renoise.song()
  ssi = song.selected_sequence_index
  if #song.sequencer.pattern_sequence > ( ssi ) then
    song.selected_sequence_index = ssi + 1 --select next pattern
  end
end



--=================================================
--=================================================
--=================================================
--tables for notes (alphanumeric to latin notes) 
local table_do  = { 0,  12, 24, 36, 48, 60, 72, 84, 96,  108 }
local table_dos = { 1,  13, 25, 37, 49, 61, 73, 85, 97,  109 }
local table_re  = { 2,  14, 26, 38, 50, 62, 74, 86, 98,  110 }
local table_res = { 3,  15, 27, 39, 51, 63, 75, 87, 99,  111 }
local table_mi  = { 4,  16, 28, 40, 52, 64, 76, 88, 100, 112 }
local table_fa  = { 5,  17, 29, 41, 53, 65, 77, 89, 101, 113 }
local table_fas = { 6,  18, 30, 32, 54, 66, 78, 90, 102, 114 }
local table_sl  = { 7,  19, 31, 43, 55, 67, 79, 91, 103, 115 }
local table_sls = { 8,  20, 32, 44, 56, 68, 80, 92, 104, 116 }
local table_la  = { 9,  21, 33, 45, 57, 69, 81, 93, 105, 117 }
local table_las = { 10, 22, 34, 46, 58, 70, 82, 94, 106, 118 }
local table_si  = { 11, 23, 35, 47, 59, 71, 83, 95, 107, 119 }

--IMPORTANT NOTE, Renoise v3.1 not read correctly the fist line of each pattern using a timer or idle_obserble with playing the song. Is necessary use a filter for line 01.

--check first line only of each pattern (filter: tnc_check_pattern_first_line)
function tnc_check_pattern_first_line( song, spi, sti, line_01, note_val )
  song = renoise.song()
  spi, sti = song.selected_pattern_index, song.selected_track_index
  if ( song.selected_track.type == renoise.Track.TRACK_TYPE_SEQUENCER and song.transport.playing ) then -- only if song is playing
    if ( song.selected_pattern_index == spi ) then
      --print( "note line 01", song:pattern( spi ):track( sti ):line( 1 ):note_column( 6 ).note_string )
      for i = 1, 12 do
        line_01 = song:pattern( spi ):track( sti ):line( 1 ):note_column( i )
        if ( line_01.note_string ~= "---" ) then --line 01 empty
          if ( line_01.note_value < 120 ) then -- 120 = OFF, 121 = empty
            vb.views["TNC_NC_"..i..""].text = line_01.note_string
            vb.views["TNC_NC_"..i..""].color = tnc_tr_color() --{ 0x00,0x70,0x00 }
            --- ---Notes Latin Notation (NLN): Do, Re, Mi...
            if ( vb.views["TNC_CB_NOTES"].value == false ) then
              else
              note_val = line_01.note_value
              for note = 1, 10 do
                    if ( note_val == table_do[ note ]  ) then vb.views["TN_NC_NOTE_"..i..""].text = "DO"   --print("DO")
                elseif ( note_val == table_dos[ note ] ) then vb.views["TN_NC_NOTE_"..i..""].text = "DO#"  --print("DO#")
                elseif ( note_val == table_re[ note ]  ) then vb.views["TN_NC_NOTE_"..i..""].text = "RE"   --print("RE")
                elseif ( note_val == table_res[ note ] ) then vb.views["TN_NC_NOTE_"..i..""].text = "RE#"  --print("RE#")
                elseif ( note_val == table_mi[ note ]  ) then vb.views["TN_NC_NOTE_"..i..""].text = "MI"   --print("MI")
                elseif ( note_val == table_fa[ note ]  ) then vb.views["TN_NC_NOTE_"..i..""].text = "FA"   --print("FA")
                elseif ( note_val == table_fas[ note ] ) then vb.views["TN_NC_NOTE_"..i..""].text = "FA#"  --print("FA#")
                elseif ( note_val == table_sl[ note ]  ) then vb.views["TN_NC_NOTE_"..i..""].text = "SOL"  --print("SOL")
                elseif ( note_val == table_sls[ note ] ) then vb.views["TN_NC_NOTE_"..i..""].text = "SOL#" --print("SOL#")
                elseif ( note_val == table_la[ note ]  ) then vb.views["TN_NC_NOTE_"..i..""].text = "LA"   --print("LA")
                elseif ( note_val == table_las[ note ] ) then vb.views["TN_NC_NOTE_"..i..""].text = "LA#"  --print("LA#")
                elseif ( note_val == table_si[ note ]  ) then vb.views["TN_NC_NOTE_"..i..""].text = "SI"   --print("SI")
                end
              end
            end
           --- ---
          end
          if ( line_01.note_string == "OFF" ) then
            vb.views["TNC_NC_"..i..""].text = 'OFF'
            vb.views["TNC_NC_"..i..""].color = { 0x40,0x00,0x00 }
            if ( vb.views["TNC_CB_NOTES"].value == false ) then
              else
              vb.views["TN_NC_NOTE_"..i..""].text = "" --print("===")
            end
          end
        end
        vb.views["TN_NC_NM_"..i..""].text  = string.format(" %s", line_01.note_string )
      end
    end
  end
end

function tnc_first_line( song )
  song = renoise.song()
  if ( vb.views['TNC_CB'].value == true ) then
    if not ( song.selected_pattern_index_observable:has_notifier( tnc_check_pattern_first_line ) ) then
      song.selected_pattern_index_observable:add_notifier( tnc_check_pattern_first_line ) --observable for pattern
    end
  else
    if ( song.selected_pattern_index_observable:has_notifier( tnc_check_pattern_first_line ) ) then
      song.selected_pattern_index_observable:remove_notifier( tnc_check_pattern_first_line ) --observable for pattern
    end
  end
end

--- ---

--tnc_change_buttons ( with timer: tnc_line_timer() ). In playing song, read all the lines except the first. Not playing song, read all the lines.
function tnc_change_buttons( song, spi, sti, stpl, column_xx, note_val )
  song = renoise.song()
  spi, sti, stpl = song.selected_pattern_index, song.selected_track_index, song.transport.playback_pos.line
  --note column i
  for i = 1, 12 do
    column_xx = song.selected_line:note_column( i )
    if ( song.transport.playing ) then
      if not ( song.selected_line_index == 1 ) then
        if ( column_xx.note_string ~= "---" ) then
          if ( column_xx.note_value < 120 ) then
            vb.views["TNC_NC_"..i..""].text = column_xx.note_string
            vb.views["TNC_NC_"..i..""].color = tnc_tr_color() --{ 0x00,0x70,0x00 }
            --- --- Notes Latin Notation (NLN): Do, Re, Mi...
            if ( vb.views["TNC_CB_NOTES"].value == false ) then
              else
              note_val = column_xx.note_value
              for note = 1, 10 do
                    if ( note_val == table_do[ note ]  ) then vb.views["TN_NC_NOTE_"..i..""].text = "DO"   --print("DO")
                elseif ( note_val == table_dos[ note ] ) then vb.views["TN_NC_NOTE_"..i..""].text = "DO#"  --print("DO#")
                elseif ( note_val == table_re[ note ]  ) then vb.views["TN_NC_NOTE_"..i..""].text = "RE"   --print("RE")
                elseif ( note_val == table_res[ note ] ) then vb.views["TN_NC_NOTE_"..i..""].text = "RE#"  --print("RE#")
                elseif ( note_val == table_mi[ note ]  ) then vb.views["TN_NC_NOTE_"..i..""].text = "MI"   --print("MI")
                elseif ( note_val == table_fa[ note ]  ) then vb.views["TN_NC_NOTE_"..i..""].text = "FA"   --print("FA")
                elseif ( note_val == table_fas[ note ] ) then vb.views["TN_NC_NOTE_"..i..""].text = "FA#"  --print("FA#")
                elseif ( note_val == table_sl[ note ]  ) then vb.views["TN_NC_NOTE_"..i..""].text = "SOL"  --print("SOL")
                elseif ( note_val == table_sls[ note ] ) then vb.views["TN_NC_NOTE_"..i..""].text = "SOL#" --print("SOL#")
                elseif ( note_val == table_la[ note ]  ) then vb.views["TN_NC_NOTE_"..i..""].text = "LA"   --print("LA")
                elseif ( note_val == table_las[ note ] ) then vb.views["TN_NC_NOTE_"..i..""].text = "LA#"  --print("LA#")
                elseif ( note_val == table_si[ note ]  ) then vb.views["TN_NC_NOTE_"..i..""].text = "SI"   --print("SI")
                end
              end
            end
            --- ---
          end
          if ( column_xx.note_string == "OFF" ) then
            vb.views["TNC_NC_"..i..""].text = 'OFF'
            vb.views["TNC_NC_"..i..""].color = { 0x40,0x00,0x00 }
            if ( vb.views["TNC_CB_NOTES"].value == false ) then
              else
              vb.views["TN_NC_NOTE_"..i..""].text = "" --print("===")
            end
          end
        end
      end
      --- ---separate pattern ( SP )
      if ( vb.views['TNC_CB_SPAT'].value == true ) then
        if ( song.transport.playback_pos.line == song.patterns[ spi ].number_of_lines ) then
          tnc_df() --default values
        end
      end
      --- ---    
    else --to rescue line 01 with the song stopped.
      if ( column_xx.note_string ~= "---" ) then
        if ( column_xx.note_value < 120 ) then
          vb.views["TNC_NC_"..i..""].text = column_xx.note_string
          vb.views["TNC_NC_"..i..""].color = tnc_tr_color() --{ 0x00,0x70,0x00 }
          --- ---Notes Latin Notation ( NLN ): Do, Re, Mi...
          if ( vb.views["TNC_CB_NOTES"].value == false ) then
            else
            note_val = column_xx.note_value
            for note = 1, 10 do
                  if ( note_val == table_do[ note ]  ) then vb.views["TN_NC_NOTE_"..i..""].text = "DO"   --print("DO")
              elseif ( note_val == table_dos[ note ] ) then vb.views["TN_NC_NOTE_"..i..""].text = "DO#"  --print("DO#")
              elseif ( note_val == table_re[ note ]  ) then vb.views["TN_NC_NOTE_"..i..""].text = "RE"   --print("RE")
              elseif ( note_val == table_res[ note ] ) then vb.views["TN_NC_NOTE_"..i..""].text = "RE#"  --print("RE#")
              elseif ( note_val == table_mi[ note ]  ) then vb.views["TN_NC_NOTE_"..i..""].text = "MI"   --print("MI")
              elseif ( note_val == table_fa[ note ]  ) then vb.views["TN_NC_NOTE_"..i..""].text = "FA"   --print("FA")
              elseif ( note_val == table_fas[ note ] ) then vb.views["TN_NC_NOTE_"..i..""].text = "FA#"  --print("FA#")
              elseif ( note_val == table_sl[ note ]  ) then vb.views["TN_NC_NOTE_"..i..""].text = "SOL"  --print("SOL")
              elseif ( note_val == table_sls[ note ] ) then vb.views["TN_NC_NOTE_"..i..""].text = "SOL#" --print("SOL#")
              elseif ( note_val == table_la[ note ]  ) then vb.views["TN_NC_NOTE_"..i..""].text = "LA"   --print("LA")
              elseif ( note_val == table_las[ note ] ) then vb.views["TN_NC_NOTE_"..i..""].text = "LA#"  --print("LA#")
              elseif ( note_val == table_si[ note ]  ) then vb.views["TN_NC_NOTE_"..i..""].text = "SI"   --print("SI")
              end
            end
          end
          --- ---
        end
        if ( column_xx.note_string == "OFF" ) then
          vb.views["TNC_NC_"..i..""].text = 'OFF'
          vb.views["TNC_NC_"..i..""].color = { 0x40,0x00,0x00 }
          if ( vb.views["TNC_CB_NOTES"].value == false ) then
            else
            vb.views["TN_NC_NOTE_"..i..""].text = "" --print("===")
          end
        end
      end
    end
    vb.views["TN_NC_NM_"..i..""].text = string.format(" %s", column_xx.note_string )
  end --for i
  vb.views["TNC_TXT_LNE"].text = string.format( "%.3d", stpl - 1 ) --for read number of line  
end

--define Current_line
local CurrentLine = -1
function tnc_check_playback_line( song )
  song = renoise.song()
  if ( song.selected_track.type == renoise.Track.TRACK_TYPE_SEQUENCER ) then
    if ( CurrentLine == song.transport.playback_pos.line ) then
      return --<-- Important for not repeat the same function unnecessarily. Run the "tnc_change_buttons()" function only once for each line.
    else
      CurrentLine = song.transport.playback_pos.line --(Run the "tnc_change_buttons()" function only once for each line)
      --print("pos.line: ", song.transport.playback_pos.line )
      tnc_change_buttons()
    end
  end
end
--enable/disable the timer
function tnc_line_timer( song )
  song = renoise.song()
  if ( vb.views['TNC_CB'].value == true ) then
    
    if not ( renoise.tool():has_timer( tnc_check_playback_line ) ) then
      renoise.tool():add_timer( tnc_check_playback_line, 5 ) --timer (ms) 5 = fast max, 20 = low, 40 = very low
    end
  else
    if ( renoise.tool():has_timer( tnc_check_playback_line ) ) then
      renoise.tool():remove_timer( tnc_check_playback_line )
    end
  end
end

--- ---

--activate TNC Track Notes Checker ( tnc_line_timer, ENABLED/DISABLED )
TNC_CB = vb:checkbox { id = 'TNC_CB', value = false, notifier = function() tnc_first_line() tnc_line_timer() tnc_lps() end } --checkbox hidden -- include tnc_tr_chng()???
---
function tnc_cb_bt_ntf( song )
  song = renoise.song()
  if vb.views['TNC_CB'].value == false then
     vb.views['TNC_CB'].value = true
     vb.views['TNC_CB_BT'].color = { 0x00,0x70,0x00 }
     vb.views['TNC_CB_BT'].text = 'ENABLED'
     --- ---
     vb.views['TNC_TXT_TR'].text = song.tracks[song.selected_track_index].name
     vb.views['TNC_TXT_TR'].color = song.tracks[song.selected_track_index].color
    else
     vb.views['TNC_CB'].value = false
     vb.views['TNC_CB_BT'].color = { 0x40,0x00,0x00 }
     vb.views['TNC_CB_BT'].text = 'DISABLED'
     vb.views['TNC_CB_NOTES'].value = false
     vb.views['TNC_CB_BT_NOTES'].color = { 0x40,0x00,0x00 }
     vb.views['TNC_CB_SPAT'].value = false
     vb.views['TNC_CB_BT_SPAT'].color = { 0x40,0x00,0x00 }
  end
end
---
TNC_CB_BT = vb:button {
  id = 'TNC_CB_BT',
  width = 74,
  height = 22,
  text = 'DISABLED',
  color = { 0x40,0x00,0x00 },
  notifier = function() tnc_cb_bt_ntf() end,
  tooltip = "Enable/Disable TNC: Track Notes Checker.\nLPS = ( BPM x LPB ) / 60s\nSpeed(ms) = 60.000ms / ( BPM x LPB )\n -BPM = Beats Per Minute.\n -LPB = Lines Per Beat.\n -LPS = Lines Per Second (for a reference).\n\nNotes:\n1) TNC use a fast timer (5ms). If song is playing then you must use < ( BPM 700 & LPB 8 ) or equivalent for powerful CPU's. Use a low 'Latency (ms)' DirectSound in 'Preferences/Audio': to 10 - 40 ms. (or 10-20 ms in Asio device type).\n2) If you use a modest CPU, set low values in BPM and LPB < ( BPM 200 & 8 LPB 8)"
}


--activate NLN, Notes Latin Notation (latin): Do, Re, mi
TNC_CB_NOTES = vb:checkbox { id = 'TNC_CB_NOTES', value = false } --checkbox hidden
---
function tnc_cb_bt_notes( song )
  song = renoise.song()
  if vb.views['TNC_CB_NOTES'].value == false then
     vb.views['TNC_CB_NOTES'].value = true
     vb.views['TNC_CB_BT_NOTES'].color = { 0x00,0x70,0x00 }
    else
     vb.views['TNC_CB_NOTES'].value = false
     vb.views['TNC_CB_BT_NOTES'].color = { 0x40,0x00,0x00 }
  end
  if vb.views['TNC_CB'].value == false then
     vb.views['TNC_CB'].value = true
     vb.views['TNC_CB_BT'].color = { 0x00,0x70,0x00 }
     vb.views['TNC_CB_BT'].text = 'ENABLED'
  end
end
---
TNC_CB_BT_NOTES = vb:button {
  id = 'TNC_CB_BT_NOTES',
  width = 40,
  height = 22,
  text = 'NLN',
  color = { 0x40,0x00,0x00 },
  notifier = function() tnc_cb_bt_notes() end,
  tooltip = "Enable/Disable NLN 'Notes Latin Notation': Do, Re, Mi...\nNeed TNC to work!\n# = sharp or 'sostenido'"
}


--activate SP, Separate Patterns
TNC_CB_SPAT = vb:checkbox { id = 'TNC_CB_SPAT', value = false, notifier = function() tnc_change_buttons() end } --checkbox hidden
---
function tnc_cb_bt_spat( song )
  song = renoise.song()
  if vb.views['TNC_CB_SPAT'].value == false then
     vb.views['TNC_CB_SPAT'].value = true
     vb.views['TNC_CB_BT_SPAT'].color = { 0x00,0x70,0x00 }
    else
     vb.views['TNC_CB_SPAT'].value = false
     vb.views['TNC_CB_BT_SPAT'].color = { 0x40,0x00,0x00 }
  end
  if vb.views['TNC_CB'].value == false then
     vb.views['TNC_CB'].value = true
     vb.views['TNC_CB_BT'].color = { 0x00,0x70,0x00 }
     vb.views['TNC_CB_BT'].text = 'ENABLED'
  end
end
---
TNC_CB_BT_SPAT = vb:button {
  id = 'TNC_CB_BT_SPAT',
  width = 30,
  height = 22,
  text = 'SP',
  color = { 0x40,0x00,0x00 },
  notifier = function() tnc_cb_bt_spat() end,
  tooltip = "Enable/Disable SP 'Separate Patterns'.\nNeed TNC to work!\nNote: SP cut on the last line of each pattern. The last line will not be displayed!!!"
}


--=================================================
--=================================================
--=================================================







--------------------------------------------------------------------------------
-- ELEMENTS GUI
--------------------------------------------------------------------------------

--TNC_TXT_STI = vb: text { id = 'TNC_TXT_STI', align = 'left', text = '...' }

TNC_TXT_STI = vb:column { style = 'panel', tooltip = 'Type and order of track.',
  vb:text { id = 'TNC_TXT_STI', width = 80, height = 22, text = 'Track', font = 'bold', align = 'center' }
}

TNC_TXT_LPS = vb:column { style = 'panel', tooltip = 'LPS: Lines Per Second = ( BPM x LPB ) / 60s',
  vb:text { id = 'TNC_TXT_LPS', width = 80, height = 22, text = 'LPS: ---', font = 'bold', align = 'center' }
}

TNC_TXT_LNE = vb:column { style = 'panel', tooltip = 'Selected Line inside Track type.',
  vb:text { id = 'TNC_TXT_LNE', width = 40, height = 22, text = 'Line', font = 'bold', align = 'center' }
}

TNC_BT_DEF = vb:button { id = 'TNC_BT_DEF', width = 30, height = 22, color = { 0x00,0x20,0x50 }, text = 'DF', notifier = function() tnc_df() end,
  tooltip = 'Default/Reset values.'
}

TNC_BT_PLAY = vb:button { id = 'TNC_BT_PLAY', width = 30, height = 22, color = { 0xC0,0x50,0x00 }, bitmap = 'icons/play-ico.bmp', notifier = function() tnc_play_song() end,
  tooltip = 'Play song from initial line.'
}

TNC_BT_STP_FRST = vb:button { id = 'TNC_BT_STP_FRST', width = 56, height = 22, color = { 0xC0,0x50,0x00 }, bitmap = 'icons/stop-first-ico.bmp', notifier = function() tnc_stp_song_first() end,
  tooltip = 'Stop song with first mouse click.\nJump first line in selected pattern with second mouse click (or with first mouse click if song already stopped).'
}

TNC_BT_TR_LEFT = vb:button { id = 'TNC_BT_TR_LEFT', width = 43, height = 42, color = { 0x40,0x00,0x80 }, bitmap = 'icons/left2-ico.bmp', notifier = function() tnc_tr_left() end,
  tooltip = 'Previous track.'
}

TNC_BT_TR_RIGHT = vb:button { id = 'TNC_BT_TR_RIGHT', width = 43, height = 42, color = { 0x40,0x00,0x80 }, bitmap = 'icons/right2-ico.bmp', notifier = function() tnc_tr_right() end,
  tooltip = 'Next track.'
}


TNC_BT_TR_UP = vb:button { id = 'TNC_BT_TR_UP', width = 86, height = 16, color = { 0x40,0x00,0x80 }, bitmap = 'icons/top3-ico.bmp', notifier = function() tnc_tr_up() end,
  tooltip = 'Previous pattern.'
}

TNC_BT_TR_DOWN = vb:button { id = 'TNC_BT_TR_DOWN', width = 86, height = 16, color = { 0x40,0x00,0x80 }, bitmap = 'icons/bottom3-ico.bmp', notifier = function() tnc_tr_down() end,
  tooltip = 'Next pattern.'
}

TNC_TXT_TR = vb:button { id = 'TNC_TXT_TR', width = 576, height = 22, color = { 0x20,0x00,0x00 }, text = 'TRACK', notifier = function() tnc_play_song_cont() end,
  tooltip = 'Name and color of selected track\nPlay song from position.'
}


--------------------------------------------------------------------------------
-- GUI - TOOL 09
--------------------------------------------------------------------------------
TL09 =
vb:column {
  width = 684,
  --- ---
  vb:horizontal_aligner {
  width = 684,
    mode = 'right',
    vb:bitmap {
      bitmap = 'icons/tnc-ico.bmp',
      mode = 'body_color',
      height = 22
    },
    vb:text { font = 'bold', text = 'TNC: Track Notes Checker', height = 22 },
    vb:text { text = '   v1.0b3', height = 22 },
    vb:horizontal_aligner { width = 30 },
    TNC_TXT_STI,
    vb:horizontal_aligner { width = 5 },
    TNC_TXT_LPS, TNC_TXT_LNE,
    vb:horizontal_aligner { width = 5 },
    TNC_CB_BT, TNC_CB_BT_NOTES, TNC_CB_BT_SPAT, --TNC_CB, --TNC_CB_SPAT,
    vb:horizontal_aligner { width = 5 },
    TNC_BT_DEF,
  },
  vb:horizontal_aligner { height = 4 },
  --- ---
  vb:column { style = 'panel', margin = 8,
    vb:horizontal_aligner {
      vb:vertical_aligner {
        TNC_TXT_TR,
        vb:horizontal_aligner {
          vb:column { style = 'panel', margin = 2,
            vb:horizontal_aligner { mode = 'center',
              vb:text { text = '01  C-' }
            },
            vb:button {
              id = 'TNC_NC_1',
              width = 44,
              height = 20,
              color = { 0x20,0x00,0x00 },
              text = '---',
              tooltip = 'Jump to this column:\n01 | C- | DO',
              notifier = function() tnc_nc( 1 ) end
            },
            vb:horizontal_aligner { mode = 'center',
              vb:text { id = "TN_NC_NM_1" }
            },
            vb:horizontal_aligner { mode = 'center',
              vb:text { id = "TN_NC_NOTE_1" }
            }
          },
          vb:column { style = 'body', margin = 2,
            vb:horizontal_aligner { mode = 'center',
              vb:text { text = '02  C#' }
            },
            vb:button {
              id = 'TNC_NC_2',          
              width = 44,
              height = 20,
              color = { 0x20,0x00,0x00 },
              text = '---',
              tooltip = 'Jump to this column:\n02 | C# | DO#',
              notifier = function() tnc_nc( 2 ) end
            },
            vb:horizontal_aligner { mode = 'center',
              vb:text { id = "TN_NC_NM_2" }
            },
            vb:horizontal_aligner { mode = 'center',
              vb:text { id = "TN_NC_NOTE_2" }
            }
          },
          vb:column { style = 'panel', margin = 2,
            vb:horizontal_aligner { mode = 'center',
              vb:text { text = '03  D-' }
            },
            vb:button {
              id = 'TNC_NC_3',
              width = 44,
              height = 20,
              color = { 0x20,0x00,0x00 },
              text = '---',
              tooltip = 'Jump to this column:\n03 | D- | RE',
              notifier = function() tnc_nc( 3 ) end
            },
            vb:horizontal_aligner { mode = 'center',
              vb:text { id = "TN_NC_NM_3" }
            },
            vb:horizontal_aligner { mode = 'center',
              vb:text { id = "TN_NC_NOTE_3" }
            }
          },
          vb:column { style = 'body', margin = 2,
            vb:horizontal_aligner { mode = 'center',
              vb:text { text = '04  D#' }
            },
            vb:button {
              id = 'TNC_NC_4',
              width = 44,
              height = 20,
              color = { 0x20,0x00,0x00 },
              text = '---',
              tooltip = 'Jump to this column:\n04 | D# | RE#',
              notifier = function() tnc_nc( 4 ) end
            },
            vb:horizontal_aligner { mode = 'center',
              vb:text { id = "TN_NC_NM_4" }
            },
            vb:horizontal_aligner { mode = 'center',
              vb:text { id = "TN_NC_NOTE_4" }
            }
          },
          vb:column { style = 'panel', margin = 2,
            vb:horizontal_aligner { mode = 'center',
              vb:text { text = '05  E-' }
            },
            vb:button {
              id = 'TNC_NC_5',
              width = 44,
              height = 20,
              color = { 0x20,0x00,0x00 },
              text = '---',
              tooltip = 'Jump to this column:\n05 | E- | MI',
              notifier = function() tnc_nc( 5 ) end
            },
            vb:horizontal_aligner { mode = 'center',
              vb:text {id = "TN_NC_NM_5" }
            },
            vb:horizontal_aligner { mode = 'center',
              vb:text { id = "TN_NC_NOTE_5" }
            }
          },
          vb:column { style = 'panel', margin = 2,
            vb:horizontal_aligner { mode = 'center',
              vb:text { text = '06  F-' }
            },
            vb:button {
              id = 'TNC_NC_6',
              width = 44,
              height = 20,
              color = { 0x20,0x00,0x00 },
              text = '---',
              tooltip = 'Jump to this column:\n06 | F- | FA',
              notifier = function() tnc_nc( 6 ) end
            },
            vb:horizontal_aligner { mode = 'center',
              vb:text { id = "TN_NC_NM_6" }
            },
            vb:horizontal_aligner { mode = 'center',
              vb:text { id = "TN_NC_NOTE_6" }
            }
          },
          vb:column { style = 'body', margin = 2,
            vb:horizontal_aligner { mode = 'center',
              vb:text { text = '07  F#' }
            },
            vb:button {
              id = 'TNC_NC_7',
              width = 44,
              height = 20,
              color = { 0x20,0x00,0x00 },
              text = '---',
              tooltip = 'Jump to this column:\n07 | F# | FA#',
              notifier = function() tnc_nc( 7 ) end
            },
            vb:horizontal_aligner { mode = 'center',
              vb:text { id = "TN_NC_NM_7" }
            },
            vb:horizontal_aligner { mode = 'center',
              vb:text { id = "TN_NC_NOTE_7" }
            }
          },
          vb:column { style = 'panel', margin = 2,
            vb:horizontal_aligner { mode = 'center',
              vb:text { text = '08  G-' }
            },
            vb:button {
              id = 'TNC_NC_8',
              width = 44,
              height = 20,
              color = { 0x20,0x00,0x00 },
              text = '---',
              tooltip = 'Jump to this column:\n08 | G- | SOL',
              notifier = function() tnc_nc( 8 ) end
            },
            vb:horizontal_aligner { mode = 'center',
              vb:text { id = "TN_NC_NM_8" }
            },
            vb:horizontal_aligner { mode = 'center',
              vb:text { id = "TN_NC_NOTE_8" }
            }
          },
          vb:column { style = 'body', margin = 2,
            vb:horizontal_aligner { mode = 'center',
              vb:text { text = '09  G#' }
            },
            vb:button {
              id = 'TNC_NC_9',
              width = 44,
              height = 20,
              color = { 0x20,0x00,0x00 },
              text = '---',
              tooltip = 'Jump to this column:\n09 | G# | SOL#',
              notifier = function() tnc_nc( 9 ) end
            },
            vb:horizontal_aligner { mode = 'center',
              vb:text { id = "TN_NC_NM_9" }
            },
            vb:horizontal_aligner { mode = 'center',
              vb:text { id = "TN_NC_NOTE_9" }
            }
          },
          vb:column { style = 'panel', margin = 2,
            vb:horizontal_aligner { mode = 'center',
              vb:text { text = '10  A-' }
            },
            vb:button {
              id = 'TNC_NC_10',
              width = 44,
              height = 20,
              color = { 0x20,0x00,0x00 },
              text = '---',
              tooltip = 'Jump to this column:\n10 | A- | LA',
              notifier = function() tnc_nc( 10 ) end
            },
            vb:horizontal_aligner { mode = 'center',
              vb:text { id = "TN_NC_NM_10" }
            },
            vb:horizontal_aligner { mode = 'center',
              vb:text { id = "TN_NC_NOTE_10" }
            }
          },
          vb:column { style = 'body', margin = 2,
            vb:horizontal_aligner { mode = 'center',
              vb:text { text = '11  A#' }
            },
            vb:button {
              id = 'TNC_NC_11',
              width = 44,
              height = 20,
              color = { 0x20,0x00,0x00 },
              text = '---',
              tooltip = 'Jump to this column:\n11 | A# | LA#',
              notifier = function() tnc_nc( 11 ) end
            },
            vb:horizontal_aligner { mode = 'center',
              vb:text { id = "TN_NC_NM_11" }
            },
            vb:horizontal_aligner { mode = 'center',
              vb:text { id = "TN_NC_NOTE_11" }
            }
          },
          vb:column { style = 'panel', margin = 2,
            vb:horizontal_aligner { mode = 'center',
              vb:text { text = '12  B-' }
            },
            vb:button {
              id = 'TNC_NC_12',
              width = 44,
              height = 20,
              color = { 0x20,0x00,0x00 },
              text = '---',
              tooltip = 'Jump to this column:\n12 | B- | SI',
              notifier = function() tnc_nc( 12 ) end
            },
            vb:horizontal_aligner { mode = 'center',
              vb:text { id = "TN_NC_NM_12" }
            },
            vb:horizontal_aligner { mode = 'center',
              vb:text { id = "TN_NC_NOTE_12" }
            }
          }
        }
      },
      vb:horizontal_aligner { width = 5 },
      vb:vertical_aligner {
        vb:horizontal_aligner {
          TNC_BT_PLAY, TNC_BT_STP_FRST
        },
        vb:horizontal_aligner { height = 5 },
        TNC_BT_TR_UP,
        vb:horizontal_aligner {
          TNC_BT_TR_LEFT, TNC_BT_TR_RIGHT
        },
        TNC_BT_TR_DOWN
      }
    }
  }
}
